#uF tables for uForum - not actual for this time

#----------------------------------------------------

#- 
#- Table structure for  `uf_banlist`
#- 

CREATE TABLE `uf_banlist` (
  `b_id` mediumint(8) NOT NULL auto_increment,
  `u_id` varchar(8) NOT NULL default '-2',
  `IP` varchar(15) NOT NULL default '0.0.0.0',
  `motive` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`b_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

#- 
#- Table structure for `uf_banlist`
#- 


#----------------------------------------------------

#- 
#- Table structure for  `uf_categories`
#- 

CREATE TABLE `uf_categories` (
  `c_id` mediumint(8) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `sort` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`c_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_categories`
#- 

INSERT INTO `uf_categories` VALUES (1, 'Testowa Kategoria', 1);

#----------------------------------------------------

#- 
#- Table structure for  `uf_censorlist`
#- 

CREATE TABLE `uf_censorlist` (
  `w_id` mediumint(8) NOT NULL default '0',
  `word` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`w_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_censorlist`
#- 


#----------------------------------------------------

#- 
#- Table structure for  `uf_config`
#- 

CREATE TABLE `uf_config` (
  `name` varchar(255) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_config`
#- 

INSERT INTO `uf_config` VALUES ('forumname', 'Forum Test');
INSERT INTO `uf_config` VALUES ('forumpatch', '');
INSERT INTO `uf_config` VALUES ('meta_keywords', '');
INSERT INTO `uf_config` VALUES ('meta_description', '');
INSERT INTO `uf_config` VALUES ('defaultlang', 'Polish');
INSERT INTO `uf_config` VALUES ('defaultskin', '1');
INSERT INTO `uf_config` VALUES ('show_time_generation', '1');
INSERT INTO `uf_config` VALUES ('disable_forum', '');
INSERT INTO `uf_config` VALUES ('date_install', '1162663995');
INSERT INTO `uf_config` VALUES ('use_censorlist', '1');
INSERT INTO `uf_config` VALUES ('allow_warns', '1');
INSERT INTO `uf_config` VALUES ('warns_in_topic', '1');
INSERT INTO `uf_config` VALUES ('enable_confirms', '1');
INSERT INTO `uf_config` VALUES ('allow_send_email', '1');
INSERT INTO `uf_config` VALUES ('forum_counter','0');
INSERT INTO `uf_config` VALUES ('limit_tpid', '20');
INSERT INTO `uf_config` VALUES ('limit_ftid', '20');
INSERT INTO `uf_config` VALUES ('limit_users', '30');
INSERT INTO `uf_config` VALUES ('shoutbox_max_time', '14400');
INSERT INTO `uf_config` VALUES ('shoutbox_max', '50');
INSERT INTO `uf_config` VALUES ('view_shoutbox', '1');
INSERT INTO `uf_config` VALUES ('allow_upload_avatars', '1');
INSERT INTO `uf_config` VALUES ('forumdesc', 'Tu wpisz swój opis forum');
INSERT INTO `uf_config` VALUES ('ip_post_for_mod', '1');
INSERT INTO `uf_config` VALUES ('color_mod', 'green');
INSERT INTO `uf_config` VALUES ('color_admin', 'red');
INSERT INTO `uf_config` VALUES ('max_av_x', '150');
INSERT INTO `uf_config` VALUES ('max_av_y', '150');
INSERT INTO `uf_config` VALUES ('max_av_filesize', '102400');
INSERT INTO `uf_config` VALUES ('sig_len', '300');
INSERT INTO `uf_config` VALUES ('time_antiflood', '30');
INSERT INTO `uf_config` VALUES ('tables_width', '900');
INSERT INTO `uf_config` VALUES ('newpasswd_len', '6');
INSERT INTO `uf_config` VALUES ('posts', '1');
INSERT INTO `uf_config` VALUES ('pm_inbox_max', '10');
INSERT INTO `uf_config` VALUES ('pm_sentbox_max', '10');

#----------------------------------------------------

#- 
#- Table structure for  `uf_forums`
#- 

CREATE TABLE `uf_forums` (
  `f_id` mediumint(8) NOT NULL default '0',
  `lock` tinyint(1) NOT NULL default '0',
  `moderate` int(11) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `desc` text NOT NULL,
  `posts` mediumint(8) NOT NULL,
  `lastpost` varchar(255) NOT NULL,
  `c_id` int(8) NOT NULL default '0',
  `sort` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`f_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_forums`
#- 
INSERT INTO `uf_forums` VALUES (1, 0, 0, 'Testowe Forum', 'Pierwsze testowe forum skryptu Dynamic Script Forum.', 1, '1:1:1:1181666444:2:Admin', 1, 1);

#----------------------------------------------------

#- 
#- Table structure for  `uf_groups`
#- 

CREATE TABLE `uf_groups` (
  `g_id` mediumint(8) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `desc` varchar(255) NOT NULL default '',
  `m_id` mediumint(8) NOT NULL default '0',
  `sort` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`g_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_groups`
#- 

#----------------------------------------------------

#- 
#- Table structure for  `uf_msg_inbox`
#- 

CREATE TABLE `uf_msg_inbox` (
  `m_id` mediumint(8) NOT NULL default '0',
  `u_id` mediumint(8) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `message` text NOT NULL,
  `time` varchar(40) NOT NULL default '',
  `u_n_id` mediumint(8) NOT NULL default '0',
  `read` int(1) NOT NULL default '0',
  PRIMARY KEY  (`m_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_msg_inbox`
#- 


#----------------------------------------------------

#- 
#- Table structure for  `uf_msg_sentbox`
#- 

CREATE TABLE `uf_msg_sentbox` (
  `m_id` mediumint(8) NOT NULL default '0',
  `u_id` mediumint(8) NOT NULL default '0',
  `name` varchar(30) NOT NULL default '',
  `message` text NOT NULL,
  `time` varchar(40) NOT NULL default '',
  `u_n_id` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`m_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_msg_sentbox`
#- 


#----------------------------------------------------

#- 
#- Table structure for  `uf_posts`
#- 

CREATE TABLE `uf_posts` (
  `p_id` mediumint(8) NOT NULL default '0',
  `t_id` mediumint(8) NOT NULL default '0',
  `u_id` mediumint(8) NOT NULL default '0',
  `text` text NOT NULL,
  `user_agent` varchar(255) NOT NULL,
  `ptime` int(1) NOT NULL default '0',
  `tp_id` int(2) NOT NULL default '0',
  `f_id` mediumint(8) NOT NULL default '0',
  `moderated` int(1) NOT NULL default '0',
  `post_ip` varchar(30) NOT NULL default '0.0.0.0',
  PRIMARY KEY  (`p_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_posts`
#- 

INSERT INTO `uf_posts` VALUES
(1, 1, 1, '<b>Witamy</b> na forum opartym na skrypcie uf(Dynamic Script Forum). Miłego korzystania z niego ;)<br>W razie pytań, pisz:<br> <a href="http://pioder.gim2przemysl.int.pl/forum/">uf Forum</a>', '', 1181666444, 1, 1, 0, '127.0.0.1');

#----------------------------------------------------

#- 
#- Table structure for  `uf_sessions`
#- 

CREATE TABLE `uf_sessions` (
  `s_id` mediumint(3) NOT NULL auto_increment,
  `session_id` varchar(50) NOT NULL default '',
  `u_id` int(2) NOT NULL default '0',
  `time` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`s_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

#----------------------------------------------------

#-
#- Table structure for  `uf_shoutbox`
#-

CREATE TABLE `uf_shoutbox` (
  `m_id` mediumint(8) NOT NULL auto_increment,
  `u_id` mediumint(8) NOT NULL,
  `message` text NOT NULL,
  `mtime` varchar(20) NOT NULL,
  PRIMARY KEY  (`m_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


#- 
#- Table structure for  `uf_skins`
#- 

CREATE TABLE `uf_skins` (
  `s_id` mediumint(8) NOT NULL default '0',
  `name` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`s_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_skins`
#- 

INSERT INTO `uf_skins` VALUES (1, 'subPurple');

#----------------------------------------------------

#- 
#- Table structure for  `uf_smiles`
#- 

CREATE TABLE `uf_smiles` (
  `s_id` mediumint(8) NOT NULL default '0',
  `smile` varchar(20) NOT NULL default '',
  `url` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`s_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_smiles`
#- 

INSERT INTO `uf_smiles` VALUES (1, ':)', 'images/smiles/icon_smile.gif');
INSERT INTO `uf_smiles` VALUES (2, ';(', 'images/smiles/icon_cry.gif');
INSERT INTO `uf_smiles` VALUES (3, ':(', 'images/smiles/icon_sad.gif');
INSERT INTO `uf_smiles` VALUES (4, ':/', 'images/smiles/icon_curve.gif');
INSERT INTO `uf_smiles` VALUES (5, ':|', 'images/smiles/icon_neutral.gif');
INSERT INTO `uf_smiles` VALUES (6, ':idea:', 'images/smiles/icon_idea.gif');
INSERT INTO `uf_smiles` VALUES (7, ':lol:', 'images/smiles/icon_lol.gif');
INSERT INTO `uf_smiles` VALUES (8, ';)', 'images/smiles/icon_wink.gif');
INSERT INTO `uf_smiles` VALUES (9, ':?:', 'images/smiles/icon_question.gif');
INSERT INTO `uf_smiles` VALUES (10, ':!:', 'images/smiles/icon_exclaim.gif');
INSERT INTO `uf_smiles` VALUES (11, ':P', 'images/smiles/icon_razz.gif');
INSERT INTO `uf_smiles` VALUES (12, ':roll:', 'images/smiles/icon_rolleyes.gif');
INSERT INTO `uf_smiles` VALUES (13, ':>', 'images/smiles/icon_smile2.gif');
INSERT INTO `uf_smiles` VALUES (14, ':evil:', 'images/smiles/icon_twisted.gif');
INSERT INTO `uf_smiles` VALUES (15, ':o', 'images/smiles/icon_surprised.gif');
INSERT INTO `uf_smiles` VALUES (16, ':mad:', 'images/smiles/icon_mad.gif');
INSERT INTO `uf_smiles` VALUES (17, ':redface:', 'images/smiles/icon_redface.gif');

#----------------------------------------------------

#- 
#- Table structure for  `uf_topics`
#- 

CREATE TABLE `uf_topics` (
  `t_id` mediumint(8) NOT NULL default '0',
  `f_id` mediumint(8) NOT NULL default '0',
  `lock` int(1) NOT NULL default '0',
  `sticky` int(1) NOT NULL,
  `name` varchar(100) NOT NULL default '',
  `author` mediumint(8) NOT NULL default '0',
  `lastpost_time` int(1) NOT NULL,
  `posts` mediumint(8) NOT NULL,
  `lastpost` varchar(255) NOT NULL,
  PRIMARY KEY  (`t_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_topics`
#- 

INSERT INTO `uf_topics` VALUES (1, 1, 0, 0, 'Witamy na forum uf', 1, 0, 2, '1:1:0:2:Admin');

#----------------------------------------------------

#- 
#- Table structure for  `uf_users`
#- 

CREATE TABLE `uf_users` (
  `u_id` mediumint(8) NOT NULL default '0',
  `nick` varchar(25) NOT NULL default '',
  `pass` varchar(32) NOT NULL default '',
  `email` varchar(40) default NULL,
  `rank` int(11) NOT NULL default '0',
  `regdate` int(1) NOT NULL default '0',
  `lastvisit` int(1) NOT NULL default '0',
  `gg` int(7) NOT NULL default '0',
  `allow_gg` tinyint(1) NOT NULL default '0',
  `allow_email` tinyint(1) NOT NULL default '0',
  `allow_qr` tinyint(1) NOT NULL default '0',
  `view_shoutbox` int(1) NOT NULL default '1',
  `skin` mediumint(4) NOT NULL default '0',
  `lang` varchar(30) NOT NULL default '',
  `limit_tpid` mediumint(2) NOT NULL default '15',
  `limit_ftid` mediumint(2) NOT NULL default '20',
  `limit_users` mediumint(2) NOT NULL default '30',
  `sig` text NOT NULL,
  `avatar` varchar(100) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  `posts` int(11) NOT NULL default '0',
  `interests` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`u_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_users`
#- 

INSERT INTO `uf_users` VALUES (-1, 'Guest', 'null', NULL, 0, 0, 0, 0, 0, 0, 0, 1, 1, '', 15, 20, 30, '', '', 0, 0, '');
INSERT INTO `uf_users` VALUES (1, '%login%', '%pass%', '%email%', 2, '%regdate%', 0, 0, 1, 1, 1, 1, 1, '%lang%', 15, 20, 30, '', '', 1, 1, '');

#----------------------------------------------------

#- 
#- Table structure for  `uf_users_group`
#- 

CREATE TABLE `uf_users_group` (
  `id` mediumint(8) NOT NULL default '0',
  `u_id` mediumint(8) NOT NULL default '0',
  `g_id` mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#- 
#- Table structure for `uf_users_group`
#- 


#----------------------------------------------------

#- 
#- Table structure for  `uf_warns`
#- 

CREATE TABLE `uf_warns` (
  `w_id` mediumint(8) NOT NULL auto_increment,
  `u_id` mediumint(8) NOT NULL default '0',
  `value` varchar(10) NOT NULL default '',
  `motive` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`w_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

#- 
#- Table structure for `uf_warns`
#- 
